VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HttpConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private WWWServer As HttpServer
Attribute WWWServer.VB_VarHelpID = -1
Private WithEvents Socket As CSocket
Attribute Socket.VB_VarHelpID = -1
Private State% '=0:1.Zeile noch nicht empfangen, =1:1.Zeile empfangen
Private methode$
Private url$
Private http$
Private HeaderFieldCollection As New Collection
Private Const base64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"
Private ResultValue$
Private Laenge$

Private Sub Class_Initialize()
Set Socket = New CSocket
Socket.LineSeparator = vbCrLf
State% = 0
ResultValue$ = ""
Laenge$ = ""
End Sub

Public Sub Accept(WWW As HttpServer, Server As CSocket)
Socket.Accept Server
Set WWWServer = WWW
End Sub

Private Sub Socket_Closed()
Set Socket = Nothing
For n% = 1 To WWWServer.Clients.Count
   If WWWServer.Clients(n%) Is Me Then WWWServer.Clients.Remove n%: Exit For
Next
End Sub

Private Sub Socket_LineDataArrival(LineData As String, RemoteHostIP As String)
   
If State% = 0 Then
   methode$ = parse$(LineData, " /")
   url$ = parse$(LineData, " ")
   http$ = LineData
   If Len(http$) = 0 Then SendHttpReply
   State% = 1
ElseIf Len(LineData) = 0 Then
   SendHttpReply
Else
   HeaderFieldCollection.Add Trim$(Mid$(LineData, InStr(LineData, ":") + 1)), Left$(LineData, InStr(LineData, ":") - 1)
End If

End Sub

Private Sub SendHttpReply()

If InStr(url$, "..") Then
   SendHttpHeader 403
   Socket.SendData "<HTML><BODY>"
   Socket.SendData "<H1>Forbidden</H1>"
   Socket.SendData "You don't have permission to access /" + url$ + " on this server."
   Socket.SendData "</BODY></HTML>"
ElseIf CheckPassword() = False Then
   SendHttpHeader 401
   Socket.SendData "<HTML><BODY>"
   Socket.SendData "<H1>Authorization Required</H1>"
   Socket.SendData "This server could not verify that you are authorized to access the document you requested.  Either you supplied the wrong credentials (e.g., bad password), or your browser doesn't understand how to supply the credentials required."
   Socket.SendData "</BODY></HTML>"
Else
   d$ = WWWServer.RootDirectory: If Right$(d$, 1) <> "\" Then d$ = d$ + "\"
   file$ = d$ + url$: ersetze file$, "/", "\"
   
   If Right$(file$, 1) = "\" Then
      If exist%(file$ + WWWServer.DefaultFile) Then file$ = file$ + WWWServer.DefaultFile
   End If
   
   If Right$(file$, 1) = "\" Then
      If exist_path%(file$) = 0 Then
         SendHttpHeader 404
         Socket.SendData "<HTML><BODY>"
         Socket.SendData "<H1>File Not Found</H1>"
         Socket.SendData "The requested URL /" + url$ + " was not found on this server."
         Socket.SendData "</BODY></HTML>"
      Else
         SendHttpHeader 200, "text/html"
         Socket.SendData "<HTML><BODY>"
         If Len(url$) Then Socket.SendData "<H1>Verzeichnis " + url$ + "</H1>"
         BrowseDirectory file$
         Socket.SendData "</BODY></HTML>"
      End If
   ElseIf exist_path%(file$) = 1 Then
      SendHttpHeader 301, "http://" + HeaderField("Host") + "/" + url$ + "/"
      Socket.SendData "<HTML><BODY>"
      Socket.SendData "Moved Permanently To <A HREF=""" + parameter$ + """>" + parameter$ + "</A>"
      Socket.SendData "</BODY></HTML>"
   ElseIf exist%(file$) = 0 Then
      SendHttpHeader 404
      Socket.SendData "<HTML><BODY>"
      Socket.SendData "<H1>File Not Found</H1>"
      Socket.SendData "The requested URL /" + url$ + " was not found on this server."
      Socket.SendData "</BODY></HTML>"
   Else
      If LCase$(Right$(file$, 4)) = ".htm" Or LCase$(Right$(file$, 5)) = ".html" Then
         SendHttpHeader 200, "text/html"
      ElseIf LCase$(Right$(file$, 4)) = ".txt" Then
         SendHttpHeader 200, "text/plain"
      ElseIf LCase$(Right$(file$, 4)) = ".jpg" Or LCase$(Right$(file$, 5)) = ".jpeg" Then
         SendHttpHeader 200, "image/jpeg"
      ElseIf LCase$(Right$(file$, 4)) = ".gif" Then
         SendHttpHeader 200, "image/gif"
      Else
         SendHttpHeader 200, "application/octetstream"
      End If
      SendFile file$
   End If
End If

WWWServer.Log LogEntry$()

Socket.Disconnect

End Sub

Private Sub SendHttpHeader(returnvalue%, Optional parameter$ = "")

ResultValue$ = returnvalue%

If Len(http$) = 0 Then Exit Sub 'HTTP/0.9
   
Select Case returnvalue%
Case 200
   Socket.SendData "HTTP/1.0 200 ok"
   If Len(parameter$) Then Socket.SendData "Content-Type: " + parameter$
Case 301
   Socket.SendData "HTTP/1.0 301 Moved Permanently"
   If Len(parameter$) Then Socket.SendData "Location: " + parameter$
Case 401
   Socket.SendData "HTTP/1.0 401 Authorization Required"
   Socket.SendData "WWW-Authenticate: Basic realm=""" + WWWServer.Group + """"
Case 403
   Socket.SendData "HTTP/1.0 403 Forbidden"
Case 404
   Socket.SendData "HTTP/1.0 404 File Not Found"
Case Else
   Socket.SendData "HTTP/1.0 " & returnvalue%
End Select

Socket.SendData ""

End Sub

Private Sub SendFile(file$)

Open file$ For Binary As #1
l& = LOF(1)
Laenge$ = l&
If l& >= 5000 Then ReDim b(0 To 4999) As Byte
Do While l& > 0
   If l& < 5000 Then ReDim b(0 To l& - 1)
   Get #1, , b
   l& = l& - 5000
   Socket.SendData b
Loop
Close #1

End Sub

Private Sub BrowseDirectory(file$)

'Vaterverzeichnis
If url$ <> "" Then
   Socket.SendData "<A HREF=""../""/>Vaterverzeichnis</A><BR>"
End If

'Unterverzeichnisse
a$ = Dir$(file$ + "*.*", 16)
Do While Len(a$)
   If a$ <> "." And a$ <> ".." And (GetAttr(file$ + a$) And 16) > 0 Then
      Socket.SendData "Unterverzeichnis <A HREF=""" + a$ + "/"">" + a$ + "</A><BR>"
   End If
   a$ = Dir$
Loop

Socket.SendData "<P>"

'Dateien
a$ = Dir$(file$ + "*.*")
Do While Len(a$)
   If a$ <> "." And a$ <> ".." Then
      Socket.SendData "<A HREF=""" + a$ + """>" + a$ + "</A><BR>"
   End If
   a$ = Dir$
Loop

End Sub

Public Function HeaderField(key$)

On Error Resume Next
HeaderField = HeaderFieldCollection(key$)

End Function

Private Function CheckPassword()

If Len(WWWServer.User) = 0 Or Len(WWWServer.Password) = 0 Then CheckPassword = True: Exit Function

a$ = HeaderField("Authorization")
If Left$(a$, 6) <> "Basic " Then CheckPassword = False: Exit Function
a$ = base64_decode$(Mid$(a$, 7))
CheckPassword = a$ = WWWServer.User + ":" + WWWServer.Password

End Function

Private Function LogEntry$()

usr$ = HeaderField("Authorization")
If Left$(usr$, 6) = "Basic " Then
   usr$ = parse$(base64_decode$(Mid$(usr$, 7)), ":")
Else
   usr$ = ""
End If

LogEntry$ = Socket.RemoteHost & " - " & usr$ & " - [" & Mid$(Date$, 4, 2) & "/" & Mid$("JanFebMarAprMayJunJulAugSepOctNovDec", Val(Left$(Date$, 2)) * 3 - 2, 3) & "/" & Mid$(Date$, 7) & ":" & Time$ & "] """ & Trim$(methode$ & " /" & url$ & " " & http$) & Trim$(Trim$(""" " & ResultValue$) & " " & Laenge$)

End Function

Private Function parse$(a$, ch$)

ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If

End Function

Private Sub ersetze(a$, b$, c$)

If b$ = c$ Then Exit Sub

F% = 1
Do While InStr(F%, a$, b$)
   F% = InStr(F%, a$, b$)
   a$ = Left$(a$, F% - 1) + c$ + Mid$(a$, F% + Len(b$))
   F% = F% + Len(c$)
Loop

End Sub

Private Function exist%(ByVal a$)

On Error Resume Next
tmp% = Len(Dir$(a$, 6))
If Err Or tmp% = 0 Then
   exist% = 0
ElseIf GetAttr(a$) And 16 Then
   exist% = 0
Else
   exist% = 1
End If

End Function

Private Function exist_path%(a$)

On Error Resume Next
tmp% = Len(Dir$(a$, 16))
If Err Or tmp% = 0 Then
   exist_path% = 0
ElseIf GetAttr(a$) And 16 Then
   exist_path% = 1
Else
   exist_path% = 0
End If

End Function

Private Function base64_decode$(a$)
   c$ = ""
   For n% = 1 To Len(a$) Step 4
      w1% = mimedecode%(Mid$(a$, n%, 1))
      w2% = mimedecode%(Mid$(a$, n% + 1, 1))
      w3% = mimedecode%(Mid$(a$, n% + 2, 1))
      w4% = mimedecode%(Mid$(a$, n% + 3, 1))
      If w2% >= 0 Then c$ = c$ + Chr$(((w1% * 4 + Int(w2% / 16)) And 255))
      If w3% >= 0 Then c$ = c$ + Chr$(((w2% * 16 + Int(w3% / 4)) And 255))
      If w4% >= 0 Then c$ = c$ + Chr$(((w3% * 64 + w4%) And 255))
   Next
   base64_decode$ = c$
End Function

Private Function mimedecode%(a$)
   If Len(a$) = 0 Then mimedecode% = -1: Exit Function
   mimedecode% = InStr(base64, a$) - 1
End Function


